/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/*MAGEOUT.C   MAGE general calls mostly doing writeouts */

#include "mage.h"

/****writematrix()************************************************************/
void    writematrix()
{
        int  iout;
        
        fprintf(fpout,"@viewid {%s}\n",viewcom[iviewset]);
        fprintf(fpout,"@zoom %.2f \n",zoom);
        iout = (float)izclip/fzclip;/*fzclip scales zclip to resized screen box*/
        fprintf(fpout,"@zslab %d \n",iout);
                               
        fprintf(fpout,"@center %.3f %.3f %.3f \n"
                              ,fxcenternew,fycenternew,fzcenternew);
        fprintf(fpout,"@matrix \n");
        fprintf(fpout,"%8.5f ",a11);
        fprintf(fpout,"%8.5f ",-a12);      /*  1  2  3            1   0   0   */
        fprintf(fpout,"%8.5f ",a13);       /*  7  8  9            0   0   1   */
        fprintf(fpout,"%8.5f ",a21);       /*  4  5  6       X    0  -1   0   */
        fprintf(fpout,"%8.5f ",-a22);
        fprintf(fpout,"%8.5f ",a23);       /* screen handedness correction: */
        fprintf(fpout,"%8.5f ",a31);       /* back correct so written matrix*/
        fprintf(fpout,"%8.5f ",-a32);      /* is correct for input to this, */
        fprintf(fpout,"%8.5f\n",a33);      /* or any program                */
        fclose(fpout);
}
/*___writematrix()___________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****writefocus()*************************************************************/
void    writefocus()
{
            recondition(focusxyzstr);
            fprintf(fpout,"%s\n",focusxyzstr); /*c*/
            condition(focusxyzstr);
            fclose(fpout);
}
/*___writefocus()____________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****writerotated()***********************************************************/
void      writerotated()
{
    int    i,j;
    char   char1,char2;
    
    fprintf(fpout,"@text rotated stuff \n@kinemage 1 \n"
                              "@caption MAGE rotated and outputted \n");
    
    for(ngrp = 1; ngrp <= maxgrp ; ngrp++) 
    {/*loop-over-groups*/
      if(igrp[ngrp][6] != 0)
      {/*rotated-group*/
        recondition(groupname[ngrp]); /*MAC: make into a C string*/
        fprintf(fpout,"@group {%s} \n",groupname[ngrp]);
        condition(groupname[ngrp]);   /*MAC make into a Pascal string*/
        for(nset = igrp[ngrp][1]; nset <= igrp[ngrp][2] ; nset++)
        {/*loop-over-sets*/
          if(iset[nset][5] != 0)
          {/*rotated-set*/
            recondition(setname[nset]);
            fprintf(fpout,"@subgroup {%s} \n",setname[nset]);
            condition(setname[nset]);          
            for(nlist = iset[nset][1]; nlist <= iset[nset][2] ; nlist++)
            {/*loop-over-lists*/              
              if(ilist[nlist][5] != 0)
              {/*rotated-list*/ 
                
                recondition(listname[nlist]);
                interpretcolor(ilist[nlist][3]); 
                    /* returns color in string word */
                if(xyz(0,ilist[nlist][1])  <= 19) /*info carried by each point*/
                {  /*actual vector list, only list that can specify a rotation*/
                  if(Ltest) 
                  {
                      sprintf(alertstr,"ilist[ %d ][5] = %d\n"
                                "iset[ %d ][1] = %d, iset[ %d ][2] = %d\n"
                                "igrp[ %d ][1] = %d, igrp[ %d ][2] = %d"
                                ,nlist,ilist[nlist][5]
                                ,nset,iset[nset][1],nset,iset[nset][2]
                                ,ngrp,igrp[ngrp][1],ngrp,igrp[ngrp][2]
                                );
                      dosinglealert(); /*MACDLOG.C*/ /*MPCDLOG.C*/
                  }
                  if(   (ilist[nlist][5] <= nbondrot) 
                     && (ilist[nlist][5] >  0       ) )
                  {  /*this one does specify a rotation*/
                    fprintf(fpout,"@vectorlist {%s} color= %s"
                      " %dbondrot %.1f \n"
                      ,listname[nlist],word,ilist[nlist][5]
                      ,bondrotout[ilist[nlist][5]]);
                  }
                  else if(ilist[nlist][5] <  0) 
                  {
                    fprintf(fpout,"@vectorlist {%s} color= %s"
                      " nobutton 0bondrot 0.0 \n"
                      ,listname[nlist],word);                  
                  }
                  else 
                  {
                    fprintf(fpout,"@vectorlist {%s} color= %s\n"
                      ,listname[nlist],word);                  
                  }

                }
                else if(xyz(0,ilist[nlist][1])  <= 24)
                  fprintf(fpout,"@dotlist {%s} color= %s\n"
                            ,listname[nlist],word);
                else if(xyz(0,ilist[nlist][1])  <= 29)
                  fprintf(fpout,"@balllist {%s} color= %s radius= %.3f\n"
                            ,listname[nlist],word,radiuslist[nlist]);
                else if(xyz(0,ilist[nlist][1])  <= 39)
                  fprintf(fpout,"@labellist {%s} color= %s\n"
                            ,listname[nlist],word);
                else if(xyz(0,ilist[nlist][1])  <= 49)
                  fprintf(fpout,"@wordlist {%s} color= %s\n"
                            ,listname[nlist],word);
                condition(listname[nlist]);          
                
                if(ilist[nlist][5] >= 0)
                {
                  for( j = ilist[nlist][1] ; j <= ilist[nlist][2] ; j++)
                  {/*write-coord*/

                    for(i=0; i<(MAXPTIDCHAR+1); i++)                  /*950113*/
                    {
                        icom = (long)(MAXPTIDCHAR+1)*(long)j+(long)i; /*950113*/
                            /* offset for giant character array */
                        word[i] = ( pcom1(icom) );
                    }
                    recondition(word);
                    if(xyz(0,j) >= 10) char1 = 'P'; /*P Point*/
                    else                char1 = 'L'; /*L Line*/ /*U Unpickable*/
                    if(xyz(0,j) == 1 || xyz(0,j) == 11) char2 = 'U';
                    else                                char2 = ' ';
                    fprintf(fpout,"{%s} %c %c %.3f, %.3f, %.3f \n",
                      word,char1,char2,fxyz(0,j),fxyz(1,j),fxyz(2,j));
                  }/*write-coord*/
                }
              }/*rotated-list*/
            }/*loop-over-lists*/              
          }/*rotated-set*/
        }/*loop-over-sets*/
      }/*rotated-group*/
    }/*loop-over-groups*/
    fclose(fpout);
}
/*___writerotated()__________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****writedrawnew()**********************************************************/
int        writedrawnew()
{
    int         ireturn,i,j,n,nn;
    char        wart[256],char1,char2,dname[26],hold[256];
    int         hasvectorlist,hasdotlist,haslabellist,haswierdlist;
    unsigned long mask;


            /*in any case, this attempt to write a file with the drawnew */
            /*stuff relieves MAGE of worrying about saving drawnew stuff*/
            Ldrawactive = 0;  /*worry flag*/
            n = nxyz + nmarkers + maxmeasures + 3*ndrawpoint + 1;
            nn = nxyz + nmarkers + maxmeasures + 3*ndrawpoint + numberline;
            hasvectorlist = 0;
            hasdotlist    = 0;
            haslabellist  = 0;
            haswierdlist  = 0;
            /*scan to see what type of lists are present */
            for(j=n ; j<=nn; j++) /*(xyz[0][j] < 100) survived pruning*/
            {
                if(        (  xyz(0,j) >=  0 && xyz(0,j) <= 19 ) ) /*vector*/
                     hasvectorlist = 1;
                else if(   (  xyz(0,j) >= 20 && xyz(0,j) <= 29 ) ) /*dot*/
                     hasdotlist = 1;  /*should not be present*/
                else if(   (  xyz(0,j) >= 30 && xyz(0,j) <= 49 ) ) /*label*/
                     haslabellist = 1;
                else if(   (  xyz(0,j) >= 50 && xyz(0,j) <= 99 ) )
                     haswierdlist = 1;
            }
                   
            if(hasdotlist || haswierdlist)
            {
                sprintf(alertstr,"something besides vectors or labels"
                                 " in draw new stuff!");
                dosinglealert(); /*MACDLOG.C*/ /*MPCDLOG.C*/
            }
            if(hasvectorlist || haslabellist)
            {/*has vectors or labels*/
                nlist = iset[igrp[maxgrp+3][2]][1];
                recondition(listname[nlist]);
                interpretcolor(ilist[nlist][3]); 
                    /* returns color in string word */
                sprintf(temps," color= %s",word);
                sprintf(word,"%s",temps);
                if(ilist[nlist][6] == 1) sprintf(temps," nobutton ");
                else                     sprintf(temps," ");

                sprintf(numstr," "); /*clear numstr to hold place for masters*/
                if(listmaster[nlist] > 0) /*master button for this one*/
                {
                    for(i-1, i<=nmaster; i++)
                    {
                        mask = 1<<(i-1); /*see ajustmaster() in MAGEBBOX.c*/
                        if(listmaster[nlist]&mask)
                        {
                           recondition(mastername[i]); /*then combine masters*/
                           sprintf(hold,"%s master= {%s}",numstr,mastername[i]);
                           condition(mastername[i]);
                           sprintf(numstr,"%s",hold); /* combined -> numstr*/
                        }
                    }
                }

                if(ilist[nlist][0] > 0) sprintf(KineName," ");
                else                    sprintf(KineName," off ");
                
                /*radiuslist[nlist]  float property associated with this list*/
                if(radiuslist[nlist] > 0.001) /*only allow positive values now*/
                {
                    sprintf(dname," radius= %.3f ",radiuslist[nlist]);
                }
                else sprintf(dname," ");
                
                if(hasvectorlist) 
                {/*vector output*/
                    fprintf(fpout,"@vectorlist {%s}%s%s%s%s%s\n"
                      ,listname[nlist],word,temps,numstr,KineName,dname);
                    for(j=n ; j<=nn ; j++)
                    {
                        if(   (  xyz(0,j) >=  0 && xyz(0,j) <= 19 ) ) /*vector*/
                        {

                            for(i=0; i<(MAXPTIDCHAR+1); i++)    /*950113*/
                            {                                   /*950113*/
                                icom = (long)(MAXPTIDCHAR+1)*(long)j+(long)i;
                                    /* offset for giant character array */
                                wart[i] = ( pcom1(icom) );
                            }
                            recondition(wart);
                            if(xyz(0,j) >= 10) char1 = 'P'; /*P Point*/
                            else               char1 = 'L'; /*L Line*/
                                                             /*U Unpickable*/
                            if(xyz(0,j) == 1 || xyz(0,j) == 11) char2 = 'U';
                            else                                char2 = ' ';
                            fprintf(fpout,"{%s} %c %c %.3f, %.3f, %.3f \n",
                               wart,char1,char2,fxyz(0,j),fxyz(1,j),fxyz(2,j));
                        }
                    }
                }/*vector output*/

                if(haslabellist)
                {/*label output*/
                    fprintf(fpout,"@labellist {%s}%s%s%s%s%s\n"
                      ,listname[nlist],word,temps,numstr,KineName,dname);
                    for(j=n ; j<=nn ; j++)
                    {
                        if(   ( xyz(0,j) >= 30 && xyz(0,j) <= 49 ) ) /*label*/
                        {

                            for(i=0; i<(MAXPTIDCHAR+1); i++)            /*950113*/
                            {                              /*950113*/
                                icom = (long)(MAXPTIDCHAR+1)*(long)j+(long)i;
                                    /* offset for giant character array */
                                wart[i] = ( pcom1(icom) );
                            }
                            recondition(wart);
                            if(xyz(0,j) >= 10) char1 = 'P'; /*P Point*/
                            else               char1 = 'L'; /*L Line*/
                                                             /*U Unpickable*/
                            if(xyz(0,j) == 1 || xyz(0,j) == 11) char2 = 'U';
                            else                                char2 = ' ';
                            fprintf(fpout,"{%s} %c %c %.3f, %.3f, %.3f \n",
                               wart,char1,char2,fxyz(0,j),fxyz(1,j),fxyz(2,j));
                        }
                    }
                }/*label output*/
                condition(listname[nlist]);
                ireturn = 1;
            }/*has vectors or labels*/
            else
            {
                 ireturn = 0;
            }
            fclose(fpout);
            return(ireturn);
}
/*___writedrawnew()_________________________________________________________*/

/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****writepostscript()*******************************************************/
int    writepostscript()
{
            /* can't use % directly, print it as a character */
            word[0] = '%';word[1] = '!';word[2] = '\0';
            fprintf(fpout,"%c%cPS-Adobe-1.0\n%c%cTitle: kinemage\n"
               "%c%cCreator: MAGE\n"
               ,word[0],word[1],word[0],word[0],word[0],word[0]);
            fprintf(fpout,
               "save\n"
               "/Helvetica findfont\n"
               "[ 14 0 0 -14 0 0 ] makefont\n"
               "setfont\n"

               " 36 756 translate  %c 36 == half inch in from edges \n"
               " 1 -1 scale  %c 72 pixels per inch, invert y-axis \n"
               " 1 setlinejoin 1 setlinecap\n"
               ,word[0],word[0]);
            Lspecialloop = 1;
            Lpostscript = 1;
    return(1);  /*will contine writing to fpout in MAGEDRAW.C */
}
/*___writepostscript()______________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
/****writepruned()***********************************************************/
int    writepruned()
{
   int       ireturn,i,j,n,nn,k,isurvived,limitgrp,igoout;

    char      char1,char2,char3,charset[8];
    char      aname[26],bname[26],cname[26],dname[26];
    char      ename[26],fname[26],gname[26];
    float     mx[10];    
    char      wart[256],hold[256];
    unsigned long mask;

    if(   thiskinenum == 0 || thiskinenum == 1 
       || Lkinemagecount==1 && thiskinenum==kinemagenum)
    {/*first or only kinemage in this file, write text */
        
        writetext();  /*MACOUT.C*/
    }

    fprintf(fpout,"@kinemage %d \n",thiskinenum);
    writecaption();  /*MACOUT.C  MPCOUT.C*/

           fprintf(fpout,"\n"); /*ensure next keyword on a new line*/
            
           if(Lonewidth) fprintf(fpout,"@onewidth \n");
           if(Lthin) fprintf(fpout,"@thinline \n");
           if(Lperspec)  fprintf(fpout,"@perspective \n");
           
           if(multibins>1 && multibins<=10) 
                fprintf(fpout,"@multibin %d \n",multibins);
           
           for(i=1; i< MAXRESETS ;i++)
           {
             if(Lview[i])
             {/*Lview*/
               /*---------------------------------*/
               if(viewcom[i][0] != '\0') /*not null string*/
               {
                   if(i==1) fprintf(fpout,"@viewid {%s}\n",viewcom[i]);
                   else if(i<10) fprintf(fpout,"@%1dviewid {%s}\n",i,viewcom[i]);
                   else fprintf(fpout,"@%2dviewid {%s}\n",i,viewcom[i]);

               }
               if(Lzoomer[i])
               {
                   if(i==1) fprintf(fpout,"@zoom %.2f \n",zoomold[i]);
                   else if(i<10) fprintf(fpout,"@%1dzoom %.2f \n",i,zoomold[i]);
                   else fprintf(fpout,"@%2dzoom %.2f \n",i,zoomold[i]);
               }
               /*---------------------------------*/
               if(Lzcliper[i])
               {
                   if(i==1) fprintf(fpout,"@zslab %d \n",izclipold[i]);
                   else if(i<10) fprintf(fpout,"@%1dzslab %d \n"
                                             ,i,izclipold[i]);
                   else fprintf(fpout,"@%2dzslab %d \n",i,izclipold[i]);

               }
               /*----------------------------------*/
               if(Lcenter[i])
               {
                   if(i==1) fprintf(fpout,"@center %.3f %.3f %.3f \n"
                              ,fxcenterold[i],fycenterold[i],fzcenterold[i]);
                   else if(i<10) fprintf(fpout,"@%1dcenter %.3f %.3f %.3f \n"
                              ,i,fxcenterold[i],fycenterold[i],fzcenterold[i]);
                   else fprintf(fpout,"@%2dcenter %.3f %.3f %.3f \n"
                              ,i,fxcenterold[i],fycenterold[i],fzcenterold[i]);
               }
               /*----------------------------------*/
               if(Lreset[i])
               {
                   j = i;
                   mx[1] =  ma[j][1];
                   mx[2] = -ma[j][2];    /*  1  2  3            1   0   0   */
                   mx[3] =  ma[j][3];    /*  4  5  6       X    0  -1   0   */
                   mx[4] =  ma[j][4];    /*  7  8  9            0   0   1   */
                   mx[5] = -ma[j][5];
                   mx[6] =  ma[j][6];    /* Mac handedness correction :   */
                   mx[7] =  ma[j][7];    /* back correct so written matrix*/
                   mx[8] = -ma[j][8];    /* is correct for input to this, */
                   mx[9] =  ma[j][9];    /* or any program                */

                   if(i==1) fprintf(fpout,"@matrix \n");
                   else if(i<10)fprintf(fpout,"@%1dmatrix \n",i);
                   else         fprintf(fpout,"@%2dmatrix \n",i);
                   fprintf(fpout,"%f %f %f %f %f %f %f %f %f \n",
                      mx[1],mx[2],mx[3],mx[4],mx[5],mx[6],mx[7],mx[8],mx[9]);
               }
               /*---------------------------------*/
             }/*Lview*/
           }

    if(Ldrawline && numberline>0) limitgrp = maxgrp+3;/*allows drawlines,labels*/
    else limitgrp = maxgrp;

    for(ngrp = 1; ngrp <= limitgrp ; ngrp++)
    {/*loop-over-groups*/
      isurvived = 0;
      if(igrp[ngrp][0] > -50) /*survived pickshow deletion*/
      for(nset = igrp[ngrp][1]; nset <= igrp[ngrp][2] ; nset++)
      {
          if(iset[nset][0] > -50) /*survived pickshow deletion*/
          for(nlist = iset[nset][1]; nlist <= iset[nset][2] ; nlist++)
          {
              if(ilist[nlist][0] > -50) /*survived pickshow deletion*/
              for(j = ilist[nlist][1]; j <= ilist[nlist][2] ; j++)
                  if(xyz(0,j) < 100) isurvived = 1;/*survived pruning*/
          }
      }
      if(ngrp==maxgrp+1 ||ngrp==maxgrp+2) isurvived = 0;/*markers,drawpointers*/
      if(isurvived)
      {/*survived pruning group*/
        recondition(groupname[ngrp]); /*make into a C string*/

        if     (igrp[ngrp][4] == 2) sprintf(temps," nobutton ");
        else if(igrp[ngrp][4] == 1) sprintf(temps," dominant ");
        else                        sprintf(temps," ");
        if(igrp[ngrp][7] > 0) /*this instances earlier group*/
        {
             recondition(groupname[igrp[ngrp][7]]);
             for(j=0;j<(MAXNAMECHAR);j++)   cname[j]=groupname[igrp[ngrp][7]][j+1];
             cname[(MAXNAMECHAR)]='\0';/*force C string end*/   /*950113*/
             condition(groupname[igrp[ngrp][7]]);
             sprintf(bname," instance= {%s}",cname);
        }
        else sprintf(bname," ");

        sprintf(numstr," "); /*clear numstr to hold place for masters*/
        if(groupmaster[ngrp] > 0) /*master button for this one*/
        {
            for(i-1, i<=nmaster; i++)
            {
                mask = 1<<(i-1); /*see ajustmaster() in MAGEBBOX.c*/
                if(groupmaster[ngrp]&mask)
                {
                    recondition(mastername[i]); /*then combine masters*/
                    sprintf(hold,"%s master= {%s}",numstr,mastername[i]);
                    condition(mastername[i]);
                    sprintf(numstr,"%s",hold); /* combined -> numstr*/
                }
            }
        }

        if     (igrp[ngrp][3] == 2) sprintf(word," 2animate ");
        else if(igrp[ngrp][3] == 1) sprintf(word," animate ");
        else if(igrp[ngrp][0] == 0) sprintf(word," off");
        else                        sprintf(word," ");

        if(igrp[ngrp][8] > 0) sprintf(cname," moview= %d",igrp[ngrp][8]);
        else  sprintf(cname," ");

        /*animated groups are on/off controlled by MAGE input */
        /*groupnames are given a leading space on input*/
        /*shift groupname left one space*/
        /*this also removes asterisk at beginning of animated group name*/
        for(j=0;j<(MAXNAMECHAR);j++)   aname[j]=groupname[ngrp][j+1];
        aname[(MAXNAMECHAR)]='\0';/*force C string end*/    /*950113*/

        fprintf(fpout,"@group {%s}%s%s%s%s%s \n"
                  ,aname,temps,bname,numstr,word,cname);

        condition(groupname[ngrp]); /*remake into a Pascal string*/
        /*if(ngrp == maxgrp+3) break;*/ /*do draw-new vectors-labels later*/
        if(igrp[ngrp][7] == 0) /*this group not an instance of earlier one*/
        {/*not instancing earlier group*/
        for(nset = igrp[ngrp][1]; nset <= igrp[ngrp][2] ; nset++)
        {/*loop-over-sets*/
          isurvived = 0;
          if(iset[nset][0] > -50) /*survived pickshow deletion*/
          for(nlist = iset[nset][1]; nlist <= iset[nset][2] ; nlist++)
          {
              if(ilist[nlist][0] > -50) /*survived pickshow deletion*/
              for(j = ilist[nlist][1]; j <= ilist[nlist][2] ; j++)
                    if(xyz(0,j) < 100) isurvived = 1;/*survived pruning*/
          }
          if(ngrp==maxgrp+3) if(nset==igrp[maxgrp+3][1]) isurvived=0;
             /*first set is just the little draw markers*/
          if(isurvived)
          {/*survived pruning set*/
            if(iset[nset][3] < 3) /* 3 flags never show */
            {/*explicitly name set in kinemage display list*/
              recondition(setname[nset]);
              if     (iset[nset][3] == 2) sprintf(temps," nobutton ");
              else if(iset[nset][3] == 1) sprintf(temps," dominant ");
              else                        sprintf(temps," ");
              if(iset[nset][7] > 0) /*this instances earlier set*/
              {
                 recondition(setname[iset[nset][7]]);
                 sprintf(bname," instance= {%s}",setname[iset[nset][7]]);
                 condition(setname[iset[nset][7]]);
              }
              else sprintf(bname," ");

              sprintf(numstr," "); /*clear numstr to hold place for masters*/
              if(subgroupmaster[nset] > 0) /*master button for this one*/
              {
                  for(i-1, i<=nmaster; i++)
                  {
                      mask = 1<<(i-1); /*see ajustmaster() in MAGEBBOX.c*/
                      if(subgroupmaster[nset]&mask)
                      {
                         recondition(mastername[i]); /*then combine masters*/
                         sprintf(hold,"%s master= {%s}",numstr,mastername[i]);
                         condition(mastername[i]);
                         sprintf(numstr,"%s",hold); /* combined -> numstr*/
                      }
                  }
              }
              if(iset[nset][0] > 0) sprintf(KineName," ");
              else                  sprintf(KineName," off ");

              fprintf(fpout,"@subgroup {%s}%s%s%s%s\n"
                      ,setname[nset],temps,bname,numstr,KineName);
              condition(setname[nset]);
            }/*explicitly name set in kinemage display list*/
            if(iset[nset][7] == 0) /*this set not an instance of earlier one*/
            {/*not instancing earlier set*/

            if(ngrp!=maxgrp+3)
            {/*not in the draw-new group*/

            for(nlist = iset[nset][1]; nlist <= iset[nset][2] ; nlist++)
            {/*loop-over-lists*/
              isurvived = 0;
              if(ilist[nlist][0] > -50) /*survived pickshow deletion*/
              for(j = ilist[nlist][1]; j <= ilist[nlist][2] ; j++)
                  if(xyz(0,j) < 100) isurvived = 1;/*survived pruning*/
              if(isurvived)
              {/*survived pruning list*/
                recondition(listname[nlist]);
                interpretcolor(ilist[nlist][3]);
                    /* returns color in string word */
                    /*but don't put out a color=  unless this instance really */
                    /*had its own color= originally!*/
                    /*So, rewrite string word appropriately */
                if(ilist[nlist][8] != 0)
                {
                    sprintf(temps," color= %s",word);
                    sprintf(word,"%s",temps);
                }
                else sprintf(word," ");
                if(ilist[nlist][6] == 1) sprintf(temps," nobutton ");
                else                     sprintf(temps," ");

                if(ilist[nlist][7] > 0) /*this instances earlier set*/
                {
                     recondition(listname[ilist[nlist][7]]);
                     sprintf(bname," instance= {%s}"
                                   ,listname[ilist[nlist][7]]);
                     condition(listname[ilist[nlist][7]]);
                }
                else sprintf(bname," ");

                sprintf(numstr," "); /*clear numstr to hold place for masters*/
                if(listmaster[nlist] > 0) /*master button for this one*/
                {
                    for(i-1, i<=nmaster; i++)
                    {
                        mask = 1<<(i-1); /*see ajustmaster() in MAGEBBOX.c*/
                        if(listmaster[nlist]&mask)
                        {
                           recondition(mastername[i]); /*then combine masters*/
                           sprintf(hold,"%s master= {%s}",numstr,mastername[i]);
                           condition(mastername[i]);
                           sprintf(numstr,"%s",hold); /* combined -> numstr*/
                        }
                    }
                }
                if(ilist[nlist][0] > 0) sprintf(KineName," ");
                else                    sprintf(KineName," off ");

                /*radiuslist[nlist]  float property associated with this list*/
                if(radiuslist[nlist] > 0.001)/*only allow positive values now*/
                {
                    sprintf(dname," radius= %.3f ",radiuslist[nlist]);
                }
                else sprintf(dname," ");
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
                /*type of list info carried by each point, look at first*/
                /*of course, first may have been pruned!*/
                if(  (xyz(0,ilist[nlist][1])>=  0&&xyz(0,ilist[nlist][1])<= 19)
                   ||(xyz(0,ilist[nlist][1])>= 50&&xyz(0,ilist[nlist][1])<= 69)
                   ||(xyz(0,ilist[nlist][1])>=100&&xyz(0,ilist[nlist][1])<=119)
                  )
                     /*10,11 move or 0,1 draw vector, see MAGEVSUB.C*/
                     /*2,3 displayed draw point, not for output*/
                     /*12,13 displayed move point, not for output*/
                     /*50,51,52,53 stored, not displayed, output as L*/
                     /*60,61,62,63 stored, not displayed, output as P*/        

                {/*actual vector list*/ 
                  /* only a vectorlist can specify a rotation*/
                  if(   (ilist[nlist][5] <= nbondrot) 
                     && (ilist[nlist][5] >  0       ) )
                  {/*this one does specify a rotation*/
                    fprintf(fpout,"@vectorlist {%s}%s%s%s%s%s%s"
                      " %dbondrot %.1f \n"
                      ,listname[nlist],word,temps,bname,numstr,KineName
                      ,dname
                      ,ilist[nlist][5],bondrotout[ilist[nlist][5]]);
                  }
                  else if(ilist[nlist][5] <  0) 
                  {
                    fprintf(fpout,"@vectorlist {%s}%s%s%s%s%s%s"
                      " nobutton 0bondrot 0.0 \n"
                      ,listname[nlist],word,temps,bname,numstr,KineName
                      ,dname);                  
                  }
                  else 
                  {
                   fprintf(fpout,"@vectorlist {%s}%s%s%s%s%s%s\n"
                      ,listname[nlist],word,temps,bname,numstr,KineName
                      ,dname);                  
                  }

                }
                else if(       xyz(0,ilist[nlist][1]) <= 24
                        || (   xyz(0,ilist[nlist][1]) <=124 
                            && xyz(0,ilist[nlist][1]) >=100 )
                       )  /* 20 dotlist */
                  fprintf(fpout,"@dotlist {%s}%s%s%s%s%s%s\n"
                       ,listname[nlist],word,temps,bname,numstr,KineName
                       ,dname);
               
                else if(       xyz(0,ilist[nlist][1]) <= 29
                        || (   xyz(0,ilist[nlist][1]) <=129 
                            && xyz(0,ilist[nlist][1]) >=100 )
                       )  /* 25 balllist */
                  fprintf(fpout,"@balllist {%s}%s%s%s%s%s%s\n"
                       ,listname[nlist],word,temps,bname,numstr,KineName
                       ,dname);
                else if(       xyz(0,ilist[nlist][1]) <= 39
                        || (   xyz(0,ilist[nlist][1]) <=139 
                            && xyz(0,ilist[nlist][1]) >=100 )
                       )  /* 30 labellist */
                  fprintf(fpout,"@labellist {%s}%s%s%s%s%s%s\n"
                       ,listname[nlist],word,temps,bname,numstr,KineName
                       ,dname);
                else if(       xyz(0,ilist[nlist][1]) <= 49
                        || (   xyz(0,ilist[nlist][1]) <=149 
                            && xyz(0,ilist[nlist][1]) >=100 )
                       )  /* 40 wordlist */
                {
                  
                  if(wordsfont[nlist] == 0) sprintf(ename," ");
                  else sprintf(ename," font= %d",wordsfont[nlist]);
                  if(wordsface[nlist] == 0) sprintf(fname," ");
                  else sprintf(fname," face= %d",wordsface[nlist]);
                  if(wordssize[nlist] == 0) sprintf(gname," ");
                  else sprintf(gname," size= %d",wordssize[nlist]);
                  
                  fprintf(fpout,"@wordlist {%s}%s%s%s%s%s%s%s%s%s\n"
                       ,listname[nlist],word,temps,bname,numstr,KineName
                       ,dname,ename,fname,gname);
                }
                condition(listname[nlist]);          
                
                if(  (ilist[nlist][5] >= 0)   /*expect displayed triples*/
                   &&(ilist[nlist][0] >= 0)   /*not a null list */
                   &&(ilist[nlist][7] == 0) ) /*this list not an instance */
                {/*expect triples*/
                  for( j = ilist[nlist][1] ; j <= ilist[nlist][2] ; j++)
                  {/*loop over triples*/ 
                    igoout = 0; /*look for exceptions*/
                    if(xyz(0,j) < 100) /*survived pruning*/
                    {
                        igoout = 1;
                        if(   xyz(0,j)== 2 || xyz(0,j)== 3
                           || xyz(0,j)==12 || xyz(0,j)==13 ) igoout=0;
                           /*extra, shortened vector internal to MAGE*/
                    }
                    if(igoout) /*survived exceptions*/
                    {/*write-coord*/

                      for(i=0; i<(MAXPTIDCHAR+1); i++)     /*950113*/
                      {                                    /*950113*/
                          icom = (long)(MAXPTIDCHAR+1)*(long)j+(long)i;
                             /* offset for giant character array */
                          word[i] = ( pcom1(icom) );
                      }
                      recondition(word);

                      if(   xyz(0,j) == 10 || xyz(0,j) == 11
                         || xyz(0,j) == 60 || xyz(0,j) == 61
                         || xyz(0,j) == 62 || xyz(0,j) == 63) char1 = 'P';
                         /* valid MOVE: P Point: needed! */
                      else  char1 = ' '; /*L Line or elsething*/

                      if(   xyz(0,j) ==  1 || xyz(0,j) == 11
                         || xyz(0,j) == 51 || xyz(0,j) == 53
                         || xyz(0,j) == 61 || xyz(0,j) == 63) char2 = 'U';
                      else   char2 = ' ';  /*U Unpickable*/

                      if(   xyz(0,j) == 52 || xyz(0,j) == 53
                         || xyz(0,j) == 62 || xyz(0,j) == 63) char3 = 'B';
                      else   char3 = ' ';  /*B Ball explicit*/

                      charset[0] = ' ';
                      for(k=1;k<8;k++) charset[k] = '\0';
                      k=0;
                      if(char1 == 'P') {k++;charset[k] = char1;k++;charset[k]=' ';}
                      if(char2 == 'U') {k++;charset[k] = char2;k++;charset[k]=' ';}
                      if(char3 == 'B') {k++;charset[k] = char3;k++;charset[k]=' ';}

                      if(pinwordcom((long)j) != 0)
                      {
                          for(k=0;k<=255;k++)
                          {
                              commentstr[k]
                                = pwordcom((long)pinwordcom((long)j)+(long)k);
                              if(k>2 && commentstr[j]=='\0') break;
                              /*0,1,2 can be 0 for fontstuff */
                          }
                          for(n=3;commentstr[n]!='\0';n++)
                              temps[n-3]=commentstr[n];
                          temps[n-2]='\0';

                          fprintf(fpout
                              ,"{%s} <%s>%s%.3f, %.3f, %.3f \n"
                              ,word,temps,charset
                              ,fxyz(0,j),fxyz(1,j),fxyz(2,j));
                      }
                      else
                      {
                          fprintf(fpout,"{%s}%s%.3f, %.3f, %.3f \n",
                            word,charset,fxyz(0,j),fxyz(1,j),fxyz(2,j));
                      }
                    }/*write-coord*/
                  }/*loop over triples*/
                }/*expect triples*/
              }/*survived pruning list*/
            }/*loop-over-lists*/

            }/*not in the draw-new group*/
            else
            {/* is in the draw-new group, process list differently*/
            if( writedrawnew() ==1)
            {
                ;
            }
            else
            {
                ;
            }
            }/* is in the draw-new group, process list differently*/

            }/*not instancing earlier set*/
          }//*survived pruning set*/
        }/*loop-over-sets*/
        }/*not instancing earlier group*/
      }/*survived pruning group*/
    }/*loop-over-groups*/
    ireturn = 1;
    Lpruneactive = 0;/*so know that modified kinemage saved*/
    fclose(fpout);
    return(ireturn);
}
/*___writepruned()__________________________________________________________*/
/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/
