/*3456789_123456789_123456789_123456789_123456789_123456789_123456789_12345678*/

#include "MAGE.H"
/*mageSgrp.c*/

/****getset()*****************************************************/
void    getset(int c,int Lnew)
{
static    int     Lidn,Lnum,Lfirst,Lhidden,gotinstance;
static    int     flowID,n,j;
static    char    instancename[MAXNAMECHAR+1];
          int     mask, masterfound;
/*need some of these static since getset() called repeatedly during input*/
enum    { idenID = 1, numbID = 2, skipID = 3 };

    if(Lnew)  /* initialize */
    {
        if(maxgrp == 0)  
        {/* @set without a preceeding @group, construct first group */
            ngrp++;
            maxgrp = ngrp;
            igrp[ngrp][0] = 1;/* start with display enabled */
               /*since @group expected before @set, first set number of this*/
               /*  coming group is the next nset, i.e. nset + 1, */
               /*  consistent with set number set soon*/
            igrp[ngrp][1] = nset + 1;/* starting set number of this group*/
            igrp[ngrp][2] = nset + 1;/*ending set number for now*/
               /*@set routines must adjust the set counters within the group*/
            igrp[ngrp][3] = 0;/* created group can't be an animation group */
            igrp[ngrp][4] = 0;/* created group can't be a dominant group */
            igrp[ngrp][5] = 0; /* dummy, used to be for master button*/
            igrp[ngrp][6] = 0; /* initially not flagged for special output*/
            igrp[ngrp][7] = 0; /*presume an original, not an instance*/ 
            igrp[ngrp][8] = 0;/* created group can't have a moview flag */
            igrp[ngrp][9] = 0; /*presume no balllists to start*/ 
            for(n=0;n<=MAXNAMECHAR;n++) groupname[ngrp][n] = '\0';
                               /*clear group name*/
            condition(groupname[ngrp]); /*MACMAIN.C, dummied in MPCMAIN.C*/
            groupmaster[ngrp] = 0; /*unsigned long for master button flags*/
        }
        
        Lfirst = 1;
        Lhidden = 0;
        iword = 0;
        Linstance = 0;
        if(nset >= MAXS-1) 
        {
             sprintf(alertstr,"too many subgroups!");
             dosinglealert(); /*___DLOG.C*/ 
        }
        else           nset++;
        maxset = nset;
        iset[nset][0] = 1;    /* start with display enabled */
        iset[nset][1] = nlist + 1;    /* starting list number of this set */
        iset[nset][2] = nlist + 1;    
                                /* ending list number of this set, so far */
           /*the @vector and @label routines must adjust the list counters*/
        iset[nset][3] = 0;  
        /* initialize as recessive; does not hide things below it*/
        
        iset[nset][4] = 0; /*dummy, use to be for master button*/
        iset[nset][5] = 0; /* initially not flagged for special output*/
        iset[nset][6] = 0; /* flag not used */
        iset[nset][7] = 0; /*presume an original, not an instance*/ 
        iset[nset][8] = 0; /*presume no balllists to start*/ 
        /* since @set must occur before @vector or @label, first list  */
        /* number of this coming set is the next nlist, i.e. nlist + 1  */
        /* within the set */
        igrp[ngrp][2] = nset; 
        /* adjust counter in parent group to include this set */
        
        for(n=0;n<=MAXNAMECHAR;n++) setname[nset][n] = '\0' ;  
                            /*clear subgroup name*/     
        subgroupmaster[nset] = 0; /*unsigned long for master button flags*/
        Lmaster = 0;
        Linstance = 0;
    }
    /* test character and set flow controls  */
    /* screen for a button identifier */
    if(c == '{')  /* start a button identifier */
    {
        Lidn = 0; /* Lidn only set = 1 after next identifier char read */
        Lnum = 0;
        iword = 0;
        flowID = idenID;
    }
    else if(c == '}')  /* end a button identifier */
    {
        for(n=iword ; n<MAXNAMECHAR ; n++) word[n] = '\0';
          /*revision930207 pad out identifier to } with '\0' rather than ' '*/
        word[MAXNAMECHAR] = '\0';  /* pad & end the string in c manner */
        if(Linstance)
        {/*should hold identifier of a previously defined subgroup */
            /* subgroup named, copy it to instancename */ 
            for(n=0; n<=MAXNAMECHAR ; n++)
            {    
                instancename[n] = word[n]; 
            }
            instancename[MAXNAMECHAR] = '\0'; 
            /*array has MAXNAMECHAR+1 values indexed: 0,...,MAXNAMECHAR*/
            condition(instancename); /*MACMAIN.C, dummied in MPCMAIN.C*/
            for(j=1;j<nset;j++)
            {
                if(strncompare(instancename,setname[j],MAXNAMECHAR+1) == 0)
                {
                    iset[nset][0] = 1; /* start with display enabled 950106*/
                    /*iset[nset][0] = iset[j][0];*//*inherit on-off 930912*/
                    iset[nset][1] = iset[j][1];
                        /* starting list number of this set */
                    iset[nset][2] = iset[j][2];
                        /* ending list number of this set */
                    iset[nset][3] = iset[j][3];
                        /* dominance of this set */
                    /*if(iset[nset][4] == 0)*/
                       /*iset[nset][4] = iset[j][4];*/ 
                    if(subgroupmaster[nset] == 0)
                       subgroupmaster[nset] = subgroupmaster[j]; 
                        /* master button flag for this set */
                        /*if not previously defined on this line, set to old*/
                        /*new master can also be set later on this 1st line*/
                    iset[nset][5] = iset[j][5];
                        /* special output flag of this set */ 
                    iset[nset][6] = iset[j][6]; 
                       /* flag not used */  
                    iset[nset][7] = j; /*identity of original set*/ 
                    gotinstance = 1;
                    break;
                }
            }
            if(!gotinstance)
            {
                sprintf(alertstr,
                    "instance failed, no previous subgroup has name: %s"
                    ,instancename);
                dosinglealert(); /*___DLOG.C*/ 
            }
            gotinstance = 0;
            Linstance = 0;
        }
        else if(Lmaster)
        {/*should hold identifier of a master button for this subgroup */
        
            /* master named,*/
            condition(word); /*make into a Pascal string if on Mac*/
                 /*MACMAIN.C, dummied in MPCMAIN.C*/
            if(nmaster > 0) /*previous master button requested */
            {/*see if this one matches previous a master name */ 
                masterfound = 0;
                for(j=1;j<=nmaster;j++)
                {
                  /*if(strncompare(word,mastername[j],MAXNAMECHAR+1) == 0)*/
                    if(strncompare(word,mastername[j],MAXNAMECHAR) == 0)
                    {
                       /*iset[nset][4] = j;*/
                         mask = 1<<(j-1);
                         subgroupmaster[nset] = mask + subgroupmaster[nset]; 
                             /*add to any others*/          
                         masterfound = 1;
                    }
                }
            }
            if(nmaster == 0 || masterfound == 0)
          /*if(nmaster == 0 || iset[nset][4] == 0) *//*make a new master button*/
            {
                if(nmaster+1 > 8*((int)sizeof(long)) )
                {
                    sprintf(alertstr,"#master buttons limited to %d in %s",
                                     8*((int)sizeof(long)),version); 
                    subgrouperrorreport(); /*alertstr and word*/ /*MAGESGRP.c*/
                }
                else
                {
                    nmaster++;
                    for(n=0; n<=MAXNAMECHAR ; n++)
                    {    
                        mastername[nmaster][n] = word[n]; 
                    }
                  /*iset[nset][4] = nmaster;*/
                    mask = 1<<(nmaster-1);
                    subgroupmaster[nset] = mask + subgroupmaster[nset]; 
                        /*add to any others*/
                }
            }                
            Lmaster = 0;
        }
        else
        {/*should hold identifier of this subgroup */
            /* subgroup name: copy it to subgroupname */
            for(n=0; n<=MAXNAMECHAR ; n++)
            {
                setname[nset][n] = word[n]; 
            }
            setname[nset][MAXNAMECHAR] = '\0'; /*for insurance*/
            condition(setname[nset]); /*MACMAIN.C, dummied in MPCMAIN.C*/
        }
        iword = 0;
        word[0] = ' ';
        word[1] = '\0';
        Lidn = 0;
        Lnum = 0;
        flowID = skipID;
    }
    /* now either in an identifier in which any other char accepted*/
    /* or must check the char */
    if( !Lidn && (flowID != idenID) )
    {
        if(Lfirst)  
        /* first line with @subgroup can have {name}, dominant, instance= */
        {/*Lfirst*/
            if(  c == ' '||c == ','||c == ';'||c == '\t'
               ||c == '\015' || c == '\012' || c == EOL ) 
                            /* white space */
            {
                if(iword > 0)  /* after a word */
                {
                    word[iword] = '\0';  /* end string in c manner */
/*.*/                interpretsubgroupkeyword(word,iword);
                    iword = 0;
                }
            }
            else  /* accummulate character in word */
            {
/*c*/            c = tolower(c);  /*make lowercase so case independent */
                word[iword] = c;
                iword = iword + 1;
            }
            /*if(c == '\015')  */
            if(c == EOL)  
            {
                Lfirst = 0;  /* ends first line */
            }
        }/*Lfirst*/
        else 
        {
            flowID = skipID;  
            /* if not first line, skip until upper routine finds an @ */
        }
    }
    /* Now control by flowID cases */
    /*begin-of-switch(flowID)*/                        
    switch(flowID)
    {
        case idenID:
            if(Lidn)
            {
                if(iword >= MAXNAMECHAR) 
                {
                    word[iword] = '\0';
                    sprintf(alertstr,
                       "next char: %c, exceeds %d name limit"
                       "\015expect truncated subgroup {Name}"
                       ,c,MAXNAMECHAR);
                    subgrouperrorreport(); /*alertstr and word */ /*MAGESGRP.c*/
                    flowID = skipID;
                }
                else
                {
                    word[iword] = c;
                    iword = iword + 1;
                }
            }
            else
            {
                Lidn = 1; /* get ready for the actual comment characters*/                                
            }
        break;
                            
        case skipID:
        break;
    }
    /*end-of-switch(flowID)*/
}
/*___getset()_______________________________________________________________*/

/****interpretsubgroupkeyword()**********************************************/
void    interpretsubgroupkeyword(char keyns[256],int ikeyn)
{
         ikeyn = ikeyn;  /*to avoid warning of not used*/

/*I*/    if(strncompare(keyns,"off",3) == 0) iset[nset][0] = 0;
                            /* starts with display disabled */ ;
/*I*/    if(strncompare(keyns,"-",1  ) == 0) iset[nset][0] = 0; /* historic */
/*I*/    if( (strncompare(keyns,"*",1  ) == 0) || 
            (strncompare(keyns,"dominant",8) == 0) )
         {
            iset[nset][3] = 1;  
            /* dominant subgroup: hides all lists below itself */
         }
/*I*/    if(strncompare(keyns,"nobutton",8) == 0) iset[nset][3] = 2; 
/*I*/    if(strncompare(keyns,"instance=",9) == 0) Linstance = TRUE;
/*I*/    if(strncompare(keyns,"master=",7) == 0) Lmaster = TRUE;
}
/*___interpretsubgroupkeyword()_____________________________________________*/

/****subgrouperrorreport()*******************************************************/
void subgrouperrorreport()
{
    recondition(groupname[ngrp]);  /*MACMAIN.C, dummied in MPCMAIN.C, etc.*/
    recondition(setname[nset]);
    sprintf(alertstr2,"%s",word);
    sprintf(alertstr3,
                  "\015in group[%d]: %s,  subgroup[%d]: %s "
                  ,ngrp,groupname[ngrp],nset,setname[nset]);
    DoMageDLOGreport(); /*alertstr,alertstr2,alertstr3*/ /*___DLOG.C*/
    condition(setname[nset]);
    condition(groupname[ngrp]);
}
/*___subgrouperrorreport()______________________________________________________*/

